package sun.java2d.loops;

import sun.java2d.pipe.SpanIterator;
import java.awt.image.ColorModel;
import java.awt.image.Raster;
import sun.awt.image.IntegerComponentRaster;
import sun.java2d.pipe.Region;
import java.awt.Composite;
import sun.java2d.SurfaceData;

class OpaqueCopyAnyToArgb extends Blit
{
    OpaqueCopyAnyToArgb() {
        super(SurfaceType.Any, CompositeType.SrcNoEa, SurfaceType.IntArgb);
    }
    
    @Override
    public void Blit(SurfaceData surfaceData, SurfaceData surfaceData2, Composite composite, Region region, int n, int n2, int n3, int n4, int n5, int n6) {
        Raster raster = surfaceData.getRaster(n, n2, n5, n6);
        ColorModel colorModel = surfaceData.getColorModel();
        IntegerComponentRaster integerComponentRaster = (IntegerComponentRaster)surfaceData2.getRaster(n3, n4, n5, n6);
        int[] dataStorage = integerComponentRaster.getDataStorage();
        SpanIterator spanIterator = CustomComponent.getRegionOfInterest(surfaceData, surfaceData2, region, n, n2, n3, n4, n5, n6).getSpanIterator();
        Object dataElements = null;
        int scanlineStride = integerComponentRaster.getScanlineStride();
        n -= n3;
        n2 -= n4;
        int[] array = new int[4];
        while (spanIterator.nextSpan(array)) {
            for (int n7 = integerComponentRaster.getDataOffset(0) + array[1] * scanlineStride + array[0], i = array[1]; i < array[3]; n7 += scanlineStride, ++i) {
                for (int j = array[0]; j < array[2]; ++j) {
                    dataElements = raster.getDataElements(j + n, i + n2, dataElements);
                    dataStorage[n7++] = colorModel.getRGB(dataElements);
                }
            }
        }
        integerComponentRaster.markDirty();
    }
}
